/**************************************************************

quicksort.c (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#include <stdlib.h>

#include "quicksort.h"

void TridiF(int l, int r, float *A, void **P)
{
    int i, j; 
    float x, a;      /* internal buffers */
    void *p;
	
	i = l; j = r; 
	x = A[(l+r)/2];
	do {
		while (A[i]<x) i++; 
		while (x<A[j]) j--; 
        if (i<=j) {
	        a = A[i]; A[i] = A[j]; A[j] = a;
            if (P!=NULL) { p = P[i]; P[i] = P[j]; P[j] = p; }
            i++; 
            j--; 
        }
    } while (i<=j);     

    if (l<j) TridiF(l,j,A,P);
    if (i<r) TridiF(i,r,A,P);
}

void TridiD(int l, int r, double *A, void **P)
{
    int i, j; 
    double x, a;      /* internal buffers */
    void *p;
	
	i = l; j = r; 
	x = A[(l+r)/2];
	do {
		while (A[i]<x) i++; 
		while (x<A[j]) j--; 
        if (i<=j) {
	        a = A[i]; A[i] = A[j]; A[j] = a;
            if (P!=NULL) { p = P[i]; P[i] = P[j]; P[j] = p; }
            i++; 
            j--; 
        }
    } while (i<=j);     

    if (l<j) TridiD(l,j,A,P);
    if (i<r) TridiD(i,r,A,P);
}

void QuickSortF(float *A, int n, void **P)
{
	if (n>1) TridiF(0,n-1,A,P);
}

void QuickSortD(double *A, int n, void **P)
{
	if (n>1) TridiD(0,n-1,A,P);
}
