/**************************************************************

iost.h (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef IOST_H
#define IOST_H

#define STHEADSIZE   2048             /* header length of the SBIG image file */

typedef void stfile;

void stopen(stfile **stfile, const char *filename, int *stat);
     // Opens a file and reads the header
void stclos(stfile *stfile, int *stat);
     // Frees allocated memory in stfile
void stgkys(stfile *stfile, const char *key, char *buf, int maxlen, int *stat);
void stgkyj(stfile *stfile, const char *key, long *value, int *stat);
void stgkyd(stfile *stfile, const char *key, double *value, int *stat);
     // Returns a value of a parameter (string/integer/double)
void stghpr(stfile *stfile, int *nx, int *ny, int *stat);
     // Returns the number of bits per pixel and the size of the image in pixels
void stg2dd(stfile *stfile, int flipx, int flipy, double *ccd, int *stat);
     // Copies the image data into the given buffer (array of floats)
int  stgkyn(stfile *stfile, int nkey, char *keyname, char *keyval, char *comm, int *stat);
     // Sequential read of parameters
void stgettime(void *st, int *hr, int *min, int *sec, int *stat);
void stgetdate(void *st, int *yr, int *mon, int *day, int *stat);
	// Return observation date & time

#endif
