/**************************************************************

phfun.h (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef PHFUN_H
#define PHFUN_H

struct StarType
{
  int    i;                    			/* Ordinal number */
  int    xmax, ymax;					/* Coordinates of max. brightness pixel */
  double xcen, ycen;           			/* Coordinates of centriod */
  double height;               			/* Max. brightness value */
  double roundness, sharpness; 			/* Shape indices */
  double skymod, skysig, skyskw; 		/* Sky parameters */
  double apmag[MAXAP], magerr[MAXAP];	/* Magnitudes and std. deviations */
  double fwhm;							/* FWHM in pixels */
  struct StarType *next;       			/* Pointer to next star or NULL */
};

struct ImageType
{
	int   ncol, nrow; 
	double *ccd;
	double thres, readns, phpadu, relerr;
	double skymod, skysig;
	double maglim, magsq;
	double exptime, temp, fwhm_med, fwhm_err;
	double jd;  
	char  object[MAXLINE], filter[MAXLINE];
};

typedef struct StarType  StarType;
typedef struct ImageType ImageType;

extern int ph_nstar;
extern StarType *ph_first;
extern StarType *ph_last;
extern ImageType ph_image;

void InitStarList();
void ClearStarList();
void AddStar(StarType **rec);
void FirstStar();
int  NextStar(StarType **rec);

void InitImageInfo();
void ClearImageInfo();

#endif
