/**************************************************************

phot.h (C-Munipack project)
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef PHOT_H
#define PHOT_H

/* Default values */
#define PROGNAME "muniphot"	     // Program name
#define MINSKY   20              // Min. no. of pixels used in sky level computation
#define MAXSKY   10000           // Max. no. of pixels used in sky level computation
#define OPTFILE  "muniphot.ini"  // Standard parameter file
#define APFILE   "apertures.ini" // Standard file with aperture definitions
#define SOPFILE  "muniphot.sam"  // Sample parameter file
#define SAPFILE  "apertures.sam" // Sample file with aperture definitions
#define MAXAP    12              // No. of apertures

/* Parameters */
extern double ph_readns;          // Read noise in ADU per frame
extern double ph_gain;            // Gain in e-/ADU
extern double ph_fwhm;            // FWHM od object
extern double ph_thresh;          // Threshold in sigmas
extern double ph_shrplo;          // Low sharpness cutoff
extern double ph_shrphi;          // High sharpness cutoff
extern double ph_rndlo;           // Low roundness cutoff
extern double ph_rndhi;           // High roundness cutoff
extern int    ph_fravgauto;       // Read FR_AVG from file header
extern int    ph_fravg;           // Number of frames averaged
extern int    ph_frsum;           // Number of frames summed
extern int    ph_smode;           // How to sort the stars ?
extern double ph_minvalue;		  // Low pixel cutoff
extern double ph_maxvalue;        // High pixel cutoff

/* Apertures */
extern double ph_aper[MAXAP];     // Aperture radii
extern int    ph_naper;           // Number of apertures used
extern double ph_is;              // Inner sky radius
extern double ph_os;              // Outer sky radius

#endif
